<?php
/**
 * fInteriorDesign functions and definitions
 *
 * Set up the theme and provides some helper functions, which are used in the
 * theme as custom template tags. Others are attached to action and filter
 * hooks in WordPress to change core functionality.
 *
 * When using a child theme you can override certain functions (those wrapped
 * in a function_exists() call) by defining them first in your child theme's
 * functions.php file. The child theme's functions.php file is included before
 * the parent theme's file, so the child theme functions would be used.
 *
 * @link https://codex.wordpress.org/Theme_Development
 * @link https://codex.wordpress.org/Child_Themes
 *
 * Functions that are not pluggable (not wrapped in function_exists()) are
 * instead attached to a filter or action hook.
 *
 * For more information on hooks, actions, and filters,
 * {@link https://codex.wordpress.org/Plugin_API}
 *
 * @subpackage fInteriorDesign
 * @author tishonator
 * @since fInteriorDesign 1.0.0
 *
 */

/**
 * Set a constant that holds the theme's minimum supported PHP version.
 */
define( 'FINTERIORDESIGN_MIN_PHP_VERSION', '7.0' );

/**
 * Immediately after theme switch is fired we we want to check php version and
 * revert to previously active theme if version is below our minimum.
 */
add_action( 'after_switch_theme', 'finteriordesign_test_for_min_php' );

/**
 * Switches back to the previous theme if the minimum PHP version is not met.
 */
function finteriordesign_test_for_min_php() {

	// Compare versions.
	if ( version_compare( PHP_VERSION, FINTERIORDESIGN_MIN_PHP_VERSION, '<' ) ) {
		// Site doesn't meet themes min php requirements, add notice...
		add_action( 'admin_notices', 'finteriordesign_min_php_not_met_notice' );
		// ... and switch back to previous theme.
		switch_theme( get_option( 'theme_switched' ) );
		return false;

	};
}

if ( ! function_exists( 'wp_body_open' ) ) {
        function wp_body_open() {
                do_action( 'wp_body_open' );
        }
}

/**
 * An error notice that can be displayed if the Minimum PHP version is not met.
 */
function finteriordesign_min_php_not_met_notice() {
	?>
	<div class="notice notice-error is_dismissable">
		<p>
			<?php esc_html_e( 'You need to update your PHP version to run this theme.', 'finteriordesign' ); ?> <br />
			<?php
			printf(
				/* translators: 1 is the current PHP version string, 2 is the minmum supported php version string of the theme */
				esc_html__( 'Actual version is: %1$s, required version is: %2$s.', 'finteriordesign' ),
				PHP_VERSION,
				FINTERIORDESIGN_MIN_PHP_VERSION
			); // phpcs: XSS ok.
			?>
		</p>
	</div>
	<?php
}


require_once( trailingslashit( get_template_directory() ) . 'customize-pro/class-customize.php' );

if ( ! function_exists( 'finteriordesign_setup' ) ) :
/**
 * fInteriorDesign setup.
 *
 * Set up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which
 * runs before the init hook. The init hook is too late for some features, such
 * as indicating support post thumbnails.
 *
 */
function finteriordesign_setup() {

	/*
	 * Make theme available for translation.
	 * Translations can be filed in the /languages/ directory.
	 */
	load_theme_textdomain( 'finteriordesign', get_template_directory() . '/languages' );

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );

	/*
	 * Let WordPress manage the document title.
	 */
	add_theme_support( 'title-tag' );

	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 * @link http://codex.wordpress.org/Function_Reference/add_theme_support#Post_Thumbnails
	 */
	add_theme_support( 'post-thumbnails' );


	// This theme uses wp_nav_menu() in header menu
	register_nav_menus( array(
		'primary'   => __( 'Primary Menu', 'finteriordesign' ),
		'footer'    => __( 'Footer Menu', 'finteriordesign' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add support for Block Styles.
	add_theme_support( 'wp-block-styles' );

	add_theme_support( 'editor-styles' );

	// add the visual editor to resemble the theme style
	add_editor_style( 'css/editor-style.css' );

	// add custom background				 
	add_theme_support( 'custom-background', 
				   array ('default-color'  => '#FFFFFF')
				 );

	// add content width
	global $content_width;
	if ( ! isset( $content_width ) ) {
		$content_width = 900;
	}

	// add custom header
    add_theme_support( 'custom-header', array (
                       'default-image'          => get_template_directory_uri() . '/images/headerback.jpg',
                       'random-default'         => '',
                       'flex-height'            => true,
                       'flex-width'             => true,
                       'uploads'                => true,
                       'width'                  => 900,
                       'height'                 => 100,
                       'default-text-color'        => '#000000',
                       'wp-head-callback'       => 'finteriordesign_header_style',
                    ) );


    // add custom logo
    add_theme_support( 'custom-logo', array (
                       'width'                  => 75,
                       'height'                 => 75,
                       'flex-height'            => true,
                       'flex-width'             => true,
                    ) );

    // Define and register starter content to showcase the theme on new sites.
	$starter_content = array(

		'widgets' => array(
			'sidebar-widget-area' => array(
				'search',
				'recent-posts',
				'categories',
				'archives',
			),

			
			'footer-column-1-widget-area' => array(
				'recent-comments'
			),

			'footer-column-2-widget-area' => array(
				'recent-posts'
			),

			'footer-column-3-widget-area' => array(
				'calendar'
			),
		),

		'posts' => array(
			'home',
			'blog',
			'about',
			'contact'
		),

		// Default to a static front page and assign the front and posts pages.
		'options' => array(
			'show_on_front' => 'page',
			'page_on_front' => '{{home}}',
			'page_for_posts' => '{{blog}}',
		),

		// Set the front page section theme mods to the IDs of the core-registered pages.
		'theme_mods' => array(
			'finteriordesign_slider_display' => 1,
			'finteriordesign_slide1_image' => esc_url( get_template_directory_uri() . '/images/slider/1.jpg' ),
			'finteriordesign_slide2_image' => esc_url( get_template_directory_uri() . '/images/slider/2.jpg' ),
			'finteriordesign_slide3_image' => esc_url( get_template_directory_uri() . '/images/slider/3.jpg' ),
			'finteriordesign_slide4_image' => esc_url( get_template_directory_uri() . '/images/slider/4.jpg' ),
		),

		'nav_menus' => array(

			// Assign a menu to the "primary" location.
			'primary' => array(
				'name' => __( 'Primary Menu', 'finteriordesign' ),
				'items' => array(
					'link_home',
					'page_blog',
					'page_contact',
					'page_about',
				),
			),

			// Assign a menu to the "footer" location.
			'footer' => array(
				'name' => __( 'Footer Menu', 'finteriordesign' ),
				'items' => array(
					'link_home',
					'page_about',
					'page_blog',
					'page_contact',
				),
			),
		),
	);

	$starter_content = apply_filters( 'finteriordesign_starter_content', $starter_content );
	add_theme_support( 'starter-content', $starter_content );
}
endif; // finteriordesign_setup
add_action( 'after_setup_theme', 'finteriordesign_setup' );

if ( ! function_exists( 'finteriordesign_sanitize_checkbox' ) ) :
	/**
	 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$checked`
	 * as a boolean value, either TRUE or FALSE.
	 *
	 * @param bool $checked Whether the checkbox is checked.
	 * @return bool Whether the checkbox is checked.
	 */
	function finteriordesign_sanitize_checkbox( $checked ) {
		// Boolean check.
		return ( ( isset( $checked ) && true == $checked ) ? true : false );
	}
endif; // finteriordesign_sanitize_checkbox

if ( ! function_exists( 'finteriordesign_sanitize_url' ) ) :

	function finteriordesign_sanitize_url( $url ) {
		return esc_url_raw( $url );
	}

endif; // finteriordesign_sanitize_url

/**
 * Register theme settings in the customizer
 */
function finteriordesign_customize_register( $wp_customize ) {

	/**
	 * Add Slider Section
	 */
	$wp_customize->add_section(
		'finteriordesign_slider_section',
		array(
			'title'       => __( 'Slider', 'finteriordesign' ),
			'capability'  => 'edit_theme_options',
		)
	);
	
	// Add display slider option
	$wp_customize->add_setting(
			'finteriordesign_slider_display',
			array(
					'default'           => 0,
					'sanitize_callback' => 'finteriordesign_sanitize_checkbox',
			)
	);

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'finteriordesign_slider_display',
							array(
								'label'          => __( 'Display Homepage Slider', 'finteriordesign' ),
								'section'        => 'finteriordesign_slider_section',
								'settings'       => 'finteriordesign_slider_display',
								'type'           => 'checkbox',
							)
						)
	);

	for ( $i = 1; $i <= 4; ++$i ) {

		// add a slide image
		$wp_customize->add_setting( 'finteriordesign_slide' . $i . '_image',
			array(
				'default' => get_template_directory_uri() . '/images/slider/' . $i . '.jpg',
	    		'sanitize_callback' => 'finteriordesign_sanitize_url'
			)
		);

	    $wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'finteriordesign_slide' . $i . '_image',
				array(
					'label'   	 => sprintf( esc_html__( 'Slide %s Image', 'finteriordesign' ), $i ),
					'section' 	 => 'finteriordesign_slider_section',
					'settings'   => 'finteriordesign_slide' . $i . '_image',
				) 
			)
		);	
	}

	/**
	 * Add Footer Section
	 */
	$wp_customize->add_section(
		'finteriordesign_footer_section',
		array(
			'title'       => __( 'Footer', 'finteriordesign' ),
			'capability'  => 'edit_theme_options',
		)
	);
	
	// Add footer copyright text
	$wp_customize->add_setting(
		'finteriordesign_footer_copyright',
		array(
		    'default'           => '',
		    'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'finteriordesign_footer_copyright',
        array(
            'label'          => __( 'Copyright Text', 'finteriordesign' ),
            'section'        => 'finteriordesign_footer_section',
            'settings'       => 'finteriordesign_footer_copyright',
            'type'           => 'text',
            )
        )
	);

	/**
	 * Add Animations Section
	 */
	$wp_customize->add_section(
		'finteriordesign_animations_display',
		array(
			'title'       => __( 'Animations', 'finteriordesign' ),
			'capability'  => 'edit_theme_options',
		)
	);

	// Add display Animations option
	$wp_customize->add_setting(
			'finteriordesign_animations_display',
			array(
					'default'           => 0,
					'sanitize_callback' => 'finteriordesign_sanitize_checkbox',
			)
	);

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize,
						'finteriordesign_animations_display',
							array(
								'label'          => __( 'Enable Animations', 'finteriordesign' ),
								'section'        => 'finteriordesign_animations_display',
								'settings'       => 'finteriordesign_animations_display',
								'type'           => 'checkbox',
							)
						)
	);
}

add_action('customize_register', 'finteriordesign_customize_register');

/**
 * the main function to load scripts in the fInteriorDesign theme
 * if you add a new load of script, style, etc. you can use that function
 * instead of adding a new wp_enqueue_scripts action for it.
 */
function finteriordesign_load_scripts() {

	// load main stylesheet.
	wp_enqueue_style( 'font-awesome', get_template_directory_uri() . '/css/font-awesome.min.css', array( ) );
	wp_enqueue_style( 'animate-css', get_template_directory_uri() . '/css/animate.css', array( ) );
	wp_enqueue_style( 'finteriordesign-style', get_stylesheet_uri(), array() );
	
	
	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
	
	// load JavaScript scripts
	wp_enqueue_script( 'viewportchecker', get_template_directory_uri() . '/js/viewportchecker.js', array( 'jquery' ) );

	wp_enqueue_script( 'finteriordesign-js', get_template_directory_uri() . '/js/utilities.js', array( 'jquery', 'viewportchecker', 'masonry' ) );

	$data = array(
		'loading_effect' => ( get_theme_mod('finteriordesign_animations_display', 0) == 1 ),
	);
	wp_localize_script('finteriordesign-js', 'finteriordesign_options', $data);
}

add_action( 'wp_enqueue_scripts', 'finteriordesign_load_scripts' );



/**
 * Display website's logo image
 */
function finteriordesign_show_website_logo_image_and_title() {

	if ( has_custom_logo() ) {

        the_custom_logo();
    }

    $header_text_color = get_header_textcolor();

    if ( 'blank' !== $header_text_color ) {
    
        echo '<div id="site-identity">';
        echo '<a href="' . esc_url( home_url('/') ) . '" title="' . esc_attr( get_bloginfo('name') ) . '">';
        echo '<h1 class="entry-title">' . esc_html( get_bloginfo('name') ) . '</h1>';
        echo '</a>';
        echo '<strong>' . esc_html( get_bloginfo('description') ) . '</strong>';
        echo '</div>';
    }
}

/**
 *	Displays the copyright text.
 */
function finteriordesign_show_copyright_text() {

	$footerText = get_theme_mod('finteriordesign_footer_copyright', null);

	if ( !empty( $footerText ) ) {

		echo esc_html( $footerText ) . ' | ';		
	}
}

/**
 *	widgets-init action handler. Used to register widgets and register widget areas
 */
function finteriordesign_widgets_init() {
	
	// Register Sidebar Widget.
	register_sidebar( array (
						'name'	 		 =>	 __( 'Sidebar Widget Area', 'finteriordesign'),
						'id'		 	 =>	 'sidebar-widget-area',
						'description'	 =>  __( 'The sidebar widget area', 'finteriordesign'),
						'before_widget'	 =>  '',
						'after_widget'	 =>  '',
						'before_title'	 =>  '<div class="sidebar-before-title"></div><h3 class="sidebar-title">',
						'after_title'	 =>  '</h3><div class="sidebar-after-title"></div>',
					) );

	// Register Footer Column #1
	register_sidebar( array (
							'name'			 =>  __( 'Footer Column #1', 'finteriordesign' ),
							'id' 			 =>  'footer-column-1-widget-area',
							'description'	 =>  __( 'The Footer Column #1 widget area', 'finteriordesign' ),
							'before_widget'  =>  '',
							'after_widget'	 =>  '',
							'before_title'	 =>  '<h2 class="footer-title">',
							'after_title'	 =>  '</h2><div class="footer-after-title"></div>',
						) );
	
	// Register Footer Column #2
	register_sidebar( array (
							'name'			 =>  __( 'Footer Column #2', 'finteriordesign' ),
							'id' 			 =>  'footer-column-2-widget-area',
							'description'	 =>  __( 'The Footer Column #2 widget area', 'finteriordesign' ),
							'before_widget'  =>  '',
							'after_widget'	 =>  '',
							'before_title'	 =>  '<h2 class="footer-title">',
							'after_title'	 =>  '</h2><div class="footer-after-title"></div>',
						) );
	
	// Register Footer Column #3
	register_sidebar( array (
							'name'			 =>  __( 'Footer Column #3', 'finteriordesign' ),
							'id' 			 =>  'footer-column-3-widget-area',
							'description'	 =>  __( 'The Footer Column #3 widget area', 'finteriordesign' ),
							'before_widget'  =>  '',
							'after_widget'	 =>  '',
							'before_title'	 =>  '<h2 class="footer-title">',
							'after_title'	 =>  '</h2><div class="footer-after-title"></div>',
						) );
}

add_action( 'widgets_init', 'finteriordesign_widgets_init' );

/**
 * Displays the Slider
 */
function finteriordesign_display_slider() {

	$allImages = array();

	for ( $i = 1; $i <= 4; ++$i ) {

		$defaultSlideImage = get_template_directory_uri().'/images/slider/' . $i .'.jpg';
		$slideImage = get_theme_mod( 'finteriordesign_slide'.$i.'_image', $defaultSlideImage );

		if ( $slideImage != '' ) {

			$allImages[] = $slideImage;
		}
	}

	$allImagesCount = count($allImages);

	// skip displaying of slider if there are NO images
	if ($allImagesCount == 0) {

		return;

	} else if ($allImagesCount == 1) {

		$allImages[] = $allImages[0];
		$allImages[] = $allImages[0];
		$allImages[] = $allImages[0];

	} else if ($allImagesCount == 2) {

		$allImages[] = $allImages[0];
		$allImages[] = $allImages[1];

	} else if ($allImagesCount == 3) {

		$allImages[] = $allImages[0];
	}
?>
	<!-- slider start -->
	<div class="rm_wrapper">
		<div id="rm_container" class="rm_container">
			<ul>
				<li data-images="rm_container_1" data-rotation="-15">
					<img src="<?php echo esc_url( $allImages[ 0 ] ); ?>" />
				</li>
				<li data-images="rm_container_2" data-rotation="-5">
					<img src="<?php echo esc_url( $allImages[ 1 ] ); ?>" />
				</li>
				<li data-images="rm_container_3" data-rotation="5">
					<img src="<?php echo esc_url( $allImages[ 2 ] ); ?>" />
				</li>			
				<li data-images="rm_container_4" data-rotation="15">
					<img src="<?php echo esc_url( $allImages[ 3 ] ); ?>" />
				</li>
			</ul>
			<div id="rm_mask_left" class="rm_mask_left">
			</div>
			<div id="rm_mask_right" class="rm_mask_right">
			</div>
			<div id="rm_corner_left" class="rm_corner_left">
			</div>
			<div id="rm_corner_right" class="rm_corner_right">
			</div>
			<div style="display:none;">
				<div id="rm_container_1">
					<?php
						echo '<img src="' . esc_url( $allImages[ 0 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 1 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 2 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 3 ] ) . '" />';
					?>
				</div>
				<div id="rm_container_2">
					<?php
						echo '<img src="' . esc_url( $allImages[ 1 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 2 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 3 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 0 ] ) . '" />';
					?>
				</div>
				<div id="rm_container_3">
					<?php
						echo '<img src="' . esc_url( $allImages[ 2 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 3 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 0 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 1 ] ) . '" />';
					?>
				</div>
				<div id="rm_container_4">
					<?php
						echo '<img src="' . esc_url( $allImages[ 3 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 0 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 1 ] ) . '" />';
						echo '<img src="' . esc_url( $allImages[ 2 ] ) . '" />';
					?>
				</div>
			</div>
		</div>
		<div class="rm_nav">
			<a id="rm_next" href="#" class="rm_next"></a>
			<a id="rm_prev" href="#" class="rm_prev"></a>
		</div>
	</div>
	<!-- slider end -->
<?php
}

function finteriordesign_header_style() {

    $header_text_color = get_header_textcolor();

    if ( ! has_header_image()
        && ( get_theme_support( 'custom-header', 'default-text-color' ) === $header_text_color
             || 'blank' === $header_text_color ) ) {

        return;
    }

    $headerImage = get_header_image();
?>
    <style type="text/css">
        <?php if ( has_header_image() ) : ?>

                #header-main {background-image: url("<?php echo esc_url( $headerImage ); ?>");}

        <?php endif; ?>

        <?php if ( get_theme_support( 'custom-header', 'default-text-color' ) !== $header_text_color
                    && 'blank' !== $header_text_color ) : ?>

                #header-main, #header-main h1.entry-title {color: #<?php echo sanitize_hex_color_no_hash( $header_text_color ); ?>;}

        <?php endif; ?>
    </style>
<?php
}

/**
 * Fix skip link focus in IE11.
 *
 * This does not enqueue the script because it is tiny and because it is only for IE11,
 * thus it does not warrant having an entire dedicated blocking script being loaded.
 *
 * @link https://git.io/vWdr2
 */
function finteriordesign_skip_link_focus_fix() {
	// The following is minified via `terser --compress --mangle -- js/skip-link-focus-fix.js`.
	?>
	<script>
	/(trident|msie)/i.test(navigator.userAgent)&&document.getElementById&&window.addEventListener&&window.addEventListener("hashchange",function(){var t,e=location.hash.substring(1);/^[A-z0-9_-]+$/.test(e)&&(t=document.getElementById(e))&&(/^(?:a|select|input|button|textarea)$/i.test(t.tagName)||(t.tabIndex=-1),t.focus())},!1);
	</script>
	<?php
}
add_action( 'wp_print_footer_scripts', 'finteriordesign_skip_link_focus_fix' );

function finteriordesign_register_block_styles() {

	register_block_style(
		'core/button',
		array(
			'name'  => 'btn',
			'label' => __( 'Hover Effect', 'finteriordesign' ),
		)
	);

	register_block_style(
		'core/group',
		array(
			'name'  => 'tgroup',
			'label' => __( 'Margin Bottom Space', 'finteriordesign' ),
		)
	);

	register_block_style(
		'core/site-title',
		array(
			'name'  => 'tsitetitle',
			'label' => __( 'Bold', 'finteriordesign' ),
		)
	);

	register_block_style(
		'core/post-title',
		array(
			'name'  => 'tposttitle',
			'label' => __( 'Bold', 'finteriordesign' ),
		)
	);

	register_block_style(
		'core/social-link',
		array(
			'name'  => 'tsociallinks',
			'label' => __( 'Square', 'finteriordesign' ),
		)
	);
}
add_action( 'init', 'finteriordesign_register_block_styles' );

?>
